/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Origine des sources :
    Zelda Return of the Hylian
    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/



#ifndef __BOUCLIER_H__
#define __BOUCLIER_H__

#include <SDL/SDL.h>

#include "ZoneRect.h"

class Bouclier {
    public :
        Bouclier(SDL_Surface* img, int id = 0);
        ~Bouclier();
        void draw(SDL_Surface* screen, int x, int y, ZoneRect* z, int direction = 0);
        void setZone(ZoneRect* z);
        void setAffiche(bool etBill);
    private :
        ZoneRect* zone;
        SDL_Surface* image;
        int type;
        bool affiche;
};

#endif  // Bouclier.h
