/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/


#ifndef __CLIENT_H__
#define __CLIENT_H__

#include<stdio.h>	
#include<winsock2.h>
#pragma comment(lib,"ws2_32.lib")
#include "Projectile.h"


class Jeu;

class Client;

struct thread_paramCli{
       Client* cli;
       SOCKET soc;
};

class Client {
    private :
        //UDP* gpUDP;    
            
        Jeu* gpJeu;
        int port;
        char* ip;	
	    
	    //TCP
        SOCKET sock;	
	    SOCKADDR_IN sin;
	    WSADATA wsa;
	    
	    //UDP
	    SOCKADDR_IN to;
	    fd_set readfs;
        int tosize;
	    SOCKET sockUDP;	
	    DWORD EcouteUDP();
	    DWORD EnvoiUDP();
	    DWORD DialogueTCP();
	    
	    
	    Projectile* CliProjectile;
	    
        bool stopTCP;
        bool stopUDP;
        bool attendUDP;
        
    public :
        Client(Jeu* jeu);
        int init();
        void lanceThread();
        ~Client();
        
        //void EcouteUDP();
        //void EcouteTCP();
        
        //void EnvoiUDP();
        //void EnvoiTCP();
        
        Projectile* getProjectile();
        void setProjectile(Projectile* Pro);
        
        static DWORD WINAPI ThreadLauncherStartUDP(void *cli){
			Client *c = (Client*)cli;                          
			return c->EcouteUDP();       
		}
		
		static DWORD WINAPI ThreadLauncherStart2UDP(void *cli){
			Client *c = (Client*)cli;                          
			return c->EnvoiUDP();       
		}
		
		static DWORD WINAPI ThreadLauncherStartTCP(void *cli){
			Client *c = (Client*)cli;                          
			return c->DialogueTCP();       
		}


};

#endif
