/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __PARTIE_H__
#define __PARTIE_H__

#include<stdio.h>	
#include<winsock2.h>
#pragma comment(lib,"ws2_32.lib")
#include "Projectile.h"

class Jeu;

class Partie{
	private: 
        Jeu* gpJeu;     
             
        
		int NbJoueur;
		int NbEquipe;
		int NbTypeJeu;
		int NbLimite;
		int NbArene;     
             
		int TypeJeu;
		int Limite;
		int Arene;
		
		int AfficheNom; //0 aucun, 1 tous sauf moi, 2 tous
		//int* Score;
		int jeuFini; //0 non, 1 oui
		
	public:                                        
		Partie(Jeu* jeu);
		~Partie();
		
		void init(int Type, int Lieu);

        int getNbJoueur(){return NbJoueur;}

		int getTypeJeu();
        string getTypeJeuName();
        void setTypeJeu(int a);
        
        int getLimite();
        int getLimiteVal();
        string getLimiteName();
        void setLimite(int a);
        
        int getArene();
        int getAreneToZone();
        string getAreneName();
        void setArene(int a);
        
        int getAfficheNom();
        void setAfficheNom(int a);
        void positionRevie(int & posX, int & posY);

        void Contact(int JoueurAttaque, int JoueurCible, int TypeContact);
        void ModifierJoueur(int JoueurModif);
        void AfficheClassement(SDL_Surface* gpScreen, int val);
        void FinPartie();
        int getJeuFini();
        void setJeuFini(int i);
        
        int scoreMaxSauf(int numJ);
         
        int scoreMax();
        int scoreMin();
        int scoreJoueur();
}; 


#endif

